   DECLARE FUNCTION cotaskmemalloc LIB "ole32.dll" ALIAS "cotaskmemalloc" (BYVAL DWORD) AS DWORD
   DECLARE SUB cotaskmemfree LIB "ole32.dll" ALIAS "cotaskmemfree" (BYVAL DWORD PTR)

   TYPE urldata
      hfont AS LONG
      htimer AS LONG
      hadfocus AS LONG
      frecalc AS LONG
      align AS LONG
      dtext AS ASCIIZ * 128
      utext AS ASCIIZ * 128
      dx AS LONG
      dy AS LONG
      sx AS LONG
      sy AS LONG
   END TYPE

   GLOBAL hhDlg AS LONG

   FUNCTION urlproc (BYVAL hwnd AS LONG, BYVAL wmsg AS LONG, _
                     BYVAL wparam AS LONG, BYVAL lparam AS LONG) AS LONG

      DIM purldata AS urldata PTR, i AS LONG, hasfocus AS LONG, hashand AS LONG
      DIM hdc AS LONG, sz AS sizel, rc AS rect, rcw AS rect, pt AS POINTAPI
      DIM ztext AS ASCIIZ * 256, lf AS logfont


      purldata = getwindowlong (hwnd, %gwl_userdata)
      IF ISFALSE(purldata) THEN
         purldata = cotaskmemalloc (SIZEOF(@purldata))
         setwindowlong hwnd, %gwl_userdata, purldata
         @purldata.hfont = 0
         @purldata.frecalc = %true
      END IF


      SELECT CASE wmsg
         CASE %WM_DESTROY
            deleteobject @purldata.hfont
            cotaskmemfree purldata

         CASE %wm_setfont
            IF @purldata.hfont THEN deleteobject @purldata.hfont
            getobject wparam, SIZEOF(lf), BYVAL VARPTR(lf)
            lf.lfunderline = 1
            @purldata.hfont = createfontindirect(lf)

         CASE %WM_MOUSEMOVE, %WM_PAINT, %WM_TIMER, %WM_LBUTTONUP
            IF @purldata.frecalc THEN
               @purldata.frecalc = %false

               IF @purldata.hfont = 0 THEN
                  getobject getstockobject(%default_gui_font), SIZEOF(lf), BYVAL VARPTR(lf)
                  lf.lfunderline = 1
                  @purldata.hfont = createfontindirect(lf)
               END IF

               getwindowtext hwnd, ztext, SIZEOF(ztext)
               i = INSTR(ztext, ";")
               IF i = 0 THEN
                  @purldata.utext = ztext
                  @purldata.dtext = ztext
               ELSE
                  @purldata.utext = MID$(ztext, i + 1)
                  @purldata.dtext = LEFT$(ztext, i - 1)
               END IF

               i = getwindowlong(hwnd, %gwl_style)
               IF (i AND %SS_RIGHT) = %SS_RIGHT   THEN @purldata.align = %SS_RIGHT ELSE _
               IF (i AND %SS_CENTER) = %SS_CENTER THEN @purldata.align = %SS_CENTER ELSE _
                                                       @purldata.align = %SS_LEFT

               hdc = getdc(hwnd)
               selectobject hdc, @purldata.hfont
               gettextextentpoint32 hdc, @purldata.dtext, LEN(@purldata.dtext), sz
               getclientrect hwnd, rc
               SELECT CASE @purldata.align
                  CASE %SS_CENTER: @purldata.dx = MAX(0, (rc.nright - sz.cx) \ 2)
                  CASE %SS_LEFT: @purldata.dx = 0
                  CASE %SS_RIGHT: @purldata.dx = MAX(0, rc.nright - sz.cx)
               END SELECT
               @purldata.dy = MAX(0, (rc.nbottom - sz.cy) \ 2)
               @purldata.sx = MIN(sz.cx, rc.nright - @purldata.dx)
               @purldata.sy = MIN(sz.cy, rc.nbottom - @purldata.dy)
               releasedc hwnd, hdc
            END IF

            getcursorpos pt
            getwindowrect hwnd, rcw
            getclientrect hwnd, rc

            IF (pt.x >= rcw.nleft + @purldata.dx) AND _
               (pt.x <  rcw.nleft + @purldata.dx + @purldata.sx) AND _
               (pt.y >= rcw.ntop + @purldata.dy)  AND _
               (pt.y <  rcw.ntop + @purldata.dy + @purldata.sy + 1) THEN hasfocus = 1 ELSE hasfocus = 0


            IF (wmsg = %WM_PAINT) OR (@purldata.hadfocus <> hasfocus) THEN
               @purldata.hadfocus = hasfocus

               hdc = getdc(hwnd)
               selectobject hdc, @purldata.hfont
               IF hasfocus THEN
                  setcursor loadcursor(BYVAL 0&, BYVAL %idc_hand)
                  settextcolor hdc, RGB(0, 0, 255)
                  @purldata.htimer = settimer (hwnd, 1, 100, BYVAL %null)
               ELSE
                  setcursor loadcursor(BYVAL 0&, BYVAL %idc_arrow)
                  settextcolor hdc, RGB(0, 0, 128)
                  IF @purldata.htimer THEN killtimer hwnd, @purldata.htimer: @purldata.htimer = 0
               END IF
               setbkmode hdc, %transparent
               textout hdc, @purldata.dx, @purldata.dy, @purldata.dtext, LEN(@purldata.dtext)

               releasedc hwnd, hdc
            END IF

            IF ISTRUE(hasfocus) AND (wmsg = %WM_LBUTTONUP) THEN
              GotoUrl @purldata.utext
            END IF


      END SELECT

      FUNCTION = defwindowproc(hwnd, wmsg, wparam, lparam)
  END FUNCTION

  FUNCTION registerurlctrl (hWnd AS LONG) AS LONG

     LOCAL wc          AS wndclass
     LOCAL szclassname AS ASCIIZ * 10
     LOCAL hlib        AS LONG

     hhDlg = hWnd

     szclassname      = "URL"
     wc.lpfnwndproc   = CODEPTR(urlproc)
     wc.hinstance     = getmodulehandle(BYVAL %null)
     wc.hbrbackground = getstockobject(%null_brush)
     wc.lpszclassname = VARPTR(szclassname)

     FUNCTION = registerclass(wc)

  END FUNCTION


SUB GotoUrl(url AS ASCIIZ)
   LOCAL uRes AS LONG
   LOCAL Msg  AS ASCIIZ * 127

   uRes = ShellExecute(hhDlg, "Open", "http://" + url, "", "", %SW_SHOWNORMAL)
END SUB
